package co.kr.ajinpaper.salesTask;

import androidx.appcompat.app.AppCompatActivity;
import androidx.core.app.NotificationManagerCompat;

import android.annotation.SuppressLint;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Build;
import android.os.Bundle;
import android.provider.Settings;
import android.util.Log;
import android.webkit.JavascriptInterface;
import android.webkit.WebSettings;
import android.webkit.WebView;

public class MainActivity extends AppCompatActivity {

    @SuppressLint("SetJavaScriptEnabled")
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.TIRAMISU) {
            if (!NotificationManagerCompat.from(this).areNotificationsEnabled()) {
                Intent intent = new Intent(Settings.ACTION_APP_NOTIFICATION_SETTINGS);
                intent.putExtra(Settings.EXTRA_APP_PACKAGE, getPackageName());
                startActivity(intent);
            }
        }

        WebView myWebView = (WebView) findViewById(R.id.webView);
        WebSettings webSettings = myWebView.getSettings();
        webSettings.setJavaScriptEnabled(true);
        webSettings.setDomStorageEnabled(true);
        myWebView.addJavascriptInterface(new WebAppInterface(this), "AndroidInterface");

        myWebView.loadUrl("http://10.0.2.2:80");

    }

    public class WebAppInterface {
        Context mContext;
        MainActivity mActivity;

        WebAppInterface(MainActivity activity) {
            mContext = activity;
            mActivity = activity;
        }

        @JavascriptInterface
        public String setPushToken() {
            // 앱에서 웹에 푸시 토큰 값 보내는 함수
            SharedPreferences sharedPreferences = mContext.getSharedPreferences("FCM", MODE_PRIVATE);
            final String token = sharedPreferences.getString("token", "");
            Log.d("WebView", "발송될 푸시 토큰: " + token);

            return token;
        }

        @JavascriptInterface
        public void getLoginToken(String token) {
            // 웹에서 받은 로그인 토큰을 저장 하는 함수
            Log.d("WebView", "웹에서 받은 로그인 토큰: " + token);
            SharedPreferences sharedPreferences = getSharedPreferences("login", MODE_PRIVATE);
            SharedPreferences.Editor editor = sharedPreferences.edit();
            editor.putString("token", token);
            editor.apply();
        }

        @JavascriptInterface
        public String setLoginToken() {
            // 저장된 로그인 토큰을 발송 하는 함수
            SharedPreferences sharedPreferences = mContext.getSharedPreferences("login", MODE_PRIVATE);
            final String token = sharedPreferences.getString("token", "");
            Log.d("WebView", "발송될 토큰: " + token);
            return token;
        }

        @JavascriptInterface
        public void reloadWeb() {
            runOnUiThread(new Runnable() {
                @Override
                public void run() {
                    // 로그인 후 새로고침하는 함수
                    WebView myWebView = (WebView) findViewById(R.id.webView);
                    myWebView.reload();
                }
            });
        }
    }
}